package require winapi::core

namespace eval ::winapi {
    variable WINAPI
    variable log


}

proc ::winapi::AttachThreadInput { from to attach } {
    return [__AttachThreadInput $from $to [string is true $attach]]
}

proc ::winapi::__init_process_thread { } {
    variable WINAPI
    variable log

    # Threads
    core::api GetCurrentThread {} ::winapi::HANDLE
    core::api GetCurrentProcess {} ::winapi::HANDLE
    core::api GetCurrentThreadId {} ::winapi::DWORD
    core::api GetCurrentProcessId {} ::winapi::DWORD
    core::api GetProcessIdOfThread { ::winapi::HANDLE } ::winapi::DWORD
    core::api GetProcessId { ::winapi::HANDLE } ::winapi::DWORD
    core::api GetThreadId { ::winapi::HANDLE } ::winapi::DWORD
    core::api GetProcessVersion { ::winapi::DWORD } ::winapi::DWORD
    core::api __AttachThreadInput { ::winapi::DWORD ::winapi::DWORD \
				      ::winapi::BOOL } ::winapi::BOOL

    return 1
}

# Now automatically initialises this module, once and only once
# through calling the __init procedure that was just declared above.
::winapi::core::initonce process_thread ::winapi::__init_process_thread

package provide winapi 0.2
